
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "cell.h"
#include "rif.h"

extern void	Error();

#ifndef	M_PI
#define M_PI	3.14159265358979323846
#endif
#define M_PI2	(M_PI*2.0)

int	main(argc,argv)
int	argc;
char	**argv;
{
	int		Nx,Ny,BPS,iy,ix;
	Cell		**cell;
	double		Ux,Uy,y,x,xx,yy,xy4,tm2,t2,tp2,tmp,La4,Lb4;
	unsigned	PV,pv;
	unsigned long	n;

	static struct {
		unsigned long	n;
		double		x,y,xx,yy,xy;
	} sum[(size_t)(Cell)(~0)+1],*S;

	if (argc!=4) Error("usage : t_of TIFF unitX unitY");

	ReadImageFile(argv[1],&Nx,&Ny,&BPS,&cell,NULL);

	if ((Ux=atof(argv[2]))<=0.0 ||
	    (Uy=atof(argv[3]))<=0.0) Error("bad unit length.");

	PV=(1<<BPS)-1;
	for (S=sum, pv=0; pv<=PV; pv++, S++) {
	    S->n=0; S->x=S->y=S->xx=S->yy=S->xy=0.0;
	}
	for (y=Uy/2.0, iy=0; iy<Ny; iy++, y+=Uy)
	for (x=Ux/2.0, ix=0; ix<Nx; ix++, x+=Ux) {
	    S=sum+cell[iy][ix]; ++S->n; S->x+=x; S->xx+=(x*x);
					S->y+=y; S->yy+=(y*y); S->xy+=(x*y);
	}
	for (S=sum, pv=0; pv<=PV; pv++, S++)
	    if ((n=S->n)!=0) {

#define N	(double)n

		x=S->x/N; xx=S->xx+(Ux*Ux/12.0-x*x)*N;
		y=S->y/N; yy=S->yy+(Uy*Uy/12.0-y*y)*N; xy4=(S->xy-x*y*N)*4.0;

		tm2=(xx-yy)*2.0; t2=fmod(atan2(xy4,tm2)+M_PI2,M_PI2);
		tp2=(xx+yy)*2.0; tmp=tm2*cos(t2)+xy4*sin(t2); La4=tp2-tmp;
							      Lb4=tp2+tmp;
#ifdef	OBLATE
		if (La4>Lb4) {
#else
		if (La4<Lb4) {
#endif
		    tmp=La4; La4=Lb4; Lb4=tmp; t2=fmod(t2+M_PI,M_PI2);
		}
		(void)printf("%u\t%lu\t%lg\t%lg\t%lg\t%lg\t%lg\n",
			     pv,n,x,y,t2*90.0/M_PI,sqrt(Lb4/N),sqrt(La4/N));
	}
	return 0;
}
