
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "cell.h"
#include "rif.h"

#ifdef	__MSVCRT__
#define LL_FORMAT	"I64"
#else
#define LL_FORMAT	"ll"
#endif

extern void	Error();

#ifndef	M_PI
#define M_PI	3.14159265358979323846
#endif
#define M_PI2	(M_PI*2.0)

int	main(argc,argv)
int	argc;
char	**argv;
{
	int			Nx,Ny,iy,ix;
	Cell			**cell,d;
	double			Ux,Uy,y,x,xy4,tm2,t2,tp2,tmp,La4,Lb4,
				X=0.0,Y=0.0,xx=0.0,yy=0.0,xy=0.0;
	unsigned long long	m=0;

	if (argc!=4) Error("usage : t_ofwd TIFF unitX unitY");

	ReadImageFile(argv[1],&Nx,&Ny,NULL,&cell,NULL);

	if ((Ux=atof(argv[2]))<=0.0 ||
	    (Uy=atof(argv[3]))<=0.0) Error("bad unit length.");

	for (y=Uy/2.0, iy=0; iy<Ny; iy++, y+=Uy)
	for (x=Ux/2.0, ix=0; ix<Nx; ix++, x+=Ux) {

#define D	(double)d

	    m+=(d=cell[iy][ix]); X+=(D*x); xx+=(D*x*x);
				 Y+=(D*y); yy+=(D*y*y); xy+=(D*x*y);
	}
	(void)printf("%d\t%d\t%" LL_FORMAT "u\n",Nx,Ny,m);

	if (m==0) Error("no object.");

#define M	(double)m

	x=X/M; xx+=((Ux*Ux/12.0-x*x)*M);
	y=Y/M; yy+=((Uy*Uy/12.0-y*y)*M); xy4=(xy-x*y*M)*4.0;

	tm2=(xx-yy)*2.0; t2=fmod(atan2(xy4,tm2)+M_PI2,M_PI2);
	tp2=(xx+yy)*2.0; tmp=tm2*cos(t2)+xy4*sin(t2); La4=tp2-tmp; Lb4=tp2+tmp;
#ifdef	OBLATE
	if (La4>Lb4) {
#else
	if (La4<Lb4) {
#endif
	    tmp=La4; La4=Lb4; Lb4=tmp; t2=fmod(t2+M_PI,M_PI2);
	}
	(void)printf("%lg\t%lg\t%lg\t%lg\t%lg\n",
		     x,y,t2*90.0/M_PI,sqrt(Lb4/M),sqrt(La4/M));

	return 0;
}
